=== debian/changelog ===
surgescript (0.5.4-1) unstable; urgency=medium

  * Initial release (Closes: #945104)

 -- Carlos Donizete Froes <coringao@riseup.net>  Mon, 18 Nov 2019 18:38:40 -0300
