=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE = 1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@

override_dh_install:
	# Remove empty directory (usr/include/surgescript/resources)
	find debian/surgescript/usr/include/surgescript/resources -type d -empty -delete
