## surgescript 0.5.4.2

=== debian/changelog ===
surgescript (0.5.4.2-1) unstable; urgency=medium

  * New upstream release.
  * debian/control:
    + Changed section to games.
    + Declare compliance with Debian Policy: 4.5.0.
  * Updated debian/copyright years.
  * debian/docs:
    + README.md file included.
  * debian/rules:
    + Changed to override_dh_auto_install.
    - Cleared some comments.
    + Reduced command to directory.
    + Used dh_install.
    + Added DEB_HOST_MULTIARCH variable.
    + Added dh_compress so that certain files are not compressed.
  * Update debian/upstream/metadata years.

 -- Carlos Donizete Froes <coringao@riseup.net>  Sat, 15 Feb 2020 05:10:34 -0300
