=== debian/control ===
--- 
+++ 
@@ -1,10 +1,10 @@
 Source: surgescript
-Section: graphics
+Section: games
 Priority: optional
 Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
 Uploaders: Carlos Donizete Froes <coringao@riseup.net>
 Build-Depends: cmake, debhelper-compat (= 12)
-Standards-Version: 4.4.1
+Standards-Version: 4.5.0
 Rules-Requires-Root: no
 Homepage: https://docs.opensurge2d.org
 Vcs-Browser: https://salsa.debian.org/games-team/surgescript
