=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE = 1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@

override_dh_auto_install:
	find debian/ -name resources -type d -empty -delete
	dh_install -p surgescript surgescript usr/games
	dh_install -p surgescript src/surgescript.h usr/include
	dh_install -p surgescript src/surgescript/compiler/*.h usr/include/surgescript/compiler
	dh_install -p surgescript src/surgescript/util/*.h usr/include/surgescript/util
	dh_install -p surgescript src/surgescript/runtime/*.h usr/include/surgescript/runtime
	dh_install -p surgescript src/surgescript/runtime/sslib/*.h usr/include/surgescript/runtime/sslib
	dh_install -p surgescript libsurgescript.a usr/lib/$(DEB_HOST_MULTIARCH)

override_dh_compress:
	dh_compress -X.ss
