=== debian/changelog ===
surgescript (0.5.4.4-1.1) unstable; urgency=medium

  * Non-maintainer upload.

  [ Chris Lamb ]
  * debian/rules: Pass -DCMAKE_SKIP_RPATH=ON to dh_auto_configure.
    (Closes: #992061)

 -- Vagrant Cascadian <vagrant@reproducible-builds.org>  Thu, 29 Dec 2022 13:18:46 -0800

surgescript (0.5.4.4-1) unstable; urgency=medium

  * New upstream release.
  * Changed debian/clean.
  * debian/docs:
    + CHANGES.md file included.
  * debian/control:
    + Changed section to 'libs'.
    + Switch to debhelper-compat = 13.
    + Declare compliance with Debian Policy: 4.5.1.
    + Added new packages: libsurgescript0.5.4.4 and libsurgescript-dev.
  * Added d/libsurgescript0.5.4.4.install
  * Added d/libsurgescript-dev.install
  * Added d/surgescript.install
  * debian/rules:
    - Changed override_dh_auto_install.
    + Added DEB_CFLAGS_MAINT_APPEND and DEB_LDFLAGS_MAINT_APPEND.
    + Added override_dh_auto_configure.
    + Added override_dh_missing.

 -- Carlos Donizete Froes <coringao@riseup.net>  Thu, 10 Dec 2020 01:26:49 -0300
