=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE = 1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_CFLAGS_MAINT_APPEND = -fPIE
export DEB_LDFLAGS_MAINT_APPEND = -pie

%:
	dh $@

override_dh_auto_install:
	dh_auto_install
	# find empty directory for removal.
	find debian -type d -empty -delete -printf 'removed %p\n'

override_dh_auto_configure:
	dh_auto_configure -- \
		-DLIB_SUFFIX=/$(DEB_HOST_MULTIARCH) \
		-DCMAKE_SKIP_RPATH=ON

override_dh_compress:
	dh_compress -X.ss

override_dh_missing:
	dh_missing --list-missing
