=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%surgescript-$1.tar.gz%" \
   https://github.com/alemart/surgescript/tags \
   (?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian uupdate
