## surgescript 0.5.5

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,16 +1,17 @@
 # ------------------------------------------------------------------------------
 # SurgeScript
 # A scripting language for games
-# Copyright 2016-2020 Alexandre Martins <alemartf(at)gmail(dot)com>
+# Copyright 2016-2021 Alexandre Martins <alemartf(at)gmail(dot)com>
 # ------------------------------------------------------------------------------
 
 # Project info
 cmake_minimum_required(VERSION 3.2)
 project(
     surgescript
-    VERSION 0.5.4.4
+    VERSION 0.5.5
     LANGUAGES C
 )
+set(PROJECT_YEARS "2016-2021")
 
 # Default config
 set(CMAKE_C_STANDARD 99)
@@ -27,15 +28,13 @@
 option(WANT_STATIC "Build SurgeScript as a static library" ON)
 option(WANT_EXECUTABLE "Build the surgescript executable" ON)
 set(LIB_SUFFIX "" CACHE STRING "Suffix to append to 'lib' directories, e.g., '64'") # libs must be installed to "lib64" in some systems
-set(PKGCONFIG_PATH "${CMAKE_INSTALL_PREFIX}/lib${LIB_SUFFIX}/pkgconfig" CACHE PATH "Destination folder of the pkg-config (.pc) file")
+set(PKGCONFIG_PATH "lib${LIB_SUFFIX}/pkgconfig" CACHE PATH "Destination folder of the pkg-config (.pc) file")
 if(UNIX)
-    set(METAINFO_PATH "/usr/share/metainfo" CACHE PATH "Destination folder of the metainfo file")
-    set(ICON_PATH "/usr/share/pixmaps" CACHE PATH "Destination folder of the icon file")
-    file(TO_CMAKE_PATH "${ICON_PATH}/surgescript.png" ICON_FILEPATH)
+    set(METAINFO_PATH "share/metainfo" CACHE PATH "Destination folder of the metainfo file")
+    set(ICON_PATH "share/pixmaps" CACHE PATH "Destination folder of the icon file")
 endif()
 
 # Output folder
-set(CMAKE_BINARY_DIR ${CMAKE_SOURCE_DIR})
 set(EXECUTABLE_OUTPUT_PATH ${CMAKE_BINARY_DIR})
 set(LIBRARY_OUTPUT_PATH ${CMAKE_BINARY_DIR})
 
@@ -75,11 +74,12 @@
     src/surgescript/runtime/tag_system.c
     src/surgescript/runtime/variable.c
     src/surgescript/runtime/vm.c
+    src/surgescript/runtime/vm_time.c
     src/surgescript/util/transform.c
     src/surgescript/util/utf8.c
     src/surgescript/util/util.c
     src/surgescript/util/xoroshiro128plus.c
-    ${CMAKE_CURRENT_BINARY_DIR}/info.c
+    ${CMAKE_BINARY_DIR}/src/surgescript/misc/info.c
 )
 
 # Headers
@@ -103,6 +103,7 @@
     src/surgescript/runtime/tag_system.h
     src/surgescript/runtime/variable.h
     src/surgescript/runtime/vm.h
+    src/surgescript/runtime/vm_time.h
     src/surgescript/util/fasthash.h
     src/surgescript/util/ssarray.h
     src/surgescript/util/transform.h
@@ -114,7 +115,7 @@
 
 # Generate files from templates
 function(generate_file TEMPLATE)
-    configure_file(src/surgescript/misc/${TEMPLATE}.in ${TEMPLATE} @ONLY)
+    configure_file(src/surgescript/${TEMPLATE}.in "${CMAKE_BINARY_DIR}/src/surgescript/${TEMPLATE}" @ONLY)
 endfunction()
 
 function(generate_pc_file LINKAGE)
@@ -123,23 +124,24 @@
         set(LIB_LINKAGE "-static")
     endif()
     configure_file(src/surgescript/misc/surgescript.pc.in "${LIBRARY_OUTPUT_PATH}/surgescript${LIB_LINKAGE}.pc" @ONLY)
-    install(FILES "${LIBRARY_OUTPUT_PATH}/surgescript${LIB_LINKAGE}.pc" DESTINATION "${PKGCONFIG_PATH}")
+    install(FILES "${LIBRARY_OUTPUT_PATH}/surgescript${LIB_LINKAGE}.pc" DESTINATION "${CMAKE_INSTALL_PREFIX}/${PKGCONFIG_PATH}")
 endfunction()
 
-generate_file("info.c")
+generate_file("misc/info.c")
+generate_file("util/version.h")
 
-
-# Library
+# Build the library
 if(NOT WANT_SHARED AND NOT WANT_STATIC)
     message(FATAL_ERROR "Options WANT_SHARED and WANT_STATIC are both set to OFF. Nothing to do.")
 endif()
 
 if(WANT_SHARED)
+    set(LIB_SOVERSION "${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR}.${PROJECT_VERSION_PATCH}") # x.y.z: backwards compatibility
     message(STATUS "Will build libsurgescript")
     generate_pc_file("shared")
     add_library(surgescript SHARED ${SURGESCRIPT_SOURCES} ${SURGESCRIPT_HEADERS})
     target_link_libraries(surgescript m)
-    set_target_properties(surgescript PROPERTIES VERSION ${PROJECT_VERSION})
+    set_target_properties(surgescript PROPERTIES VERSION ${PROJECT_VERSION} SOVERSION ${LIB_SOVERSION})
     install(TARGETS surgescript DESTINATION "lib${LIB_SUFFIX}")
 endif()
 
@@ -152,9 +154,11 @@
     install(TARGETS surgescript-static DESTINATION "lib${LIB_SUFFIX}")
 endif()
 
-install(DIRECTORY src/ DESTINATION include FILES_MATCHING PATTERN "*.h") # installing the headers
+# Install headers
+install(DIRECTORY src/ DESTINATION include FILES_MATCHING PATTERN "*.h")
+install(DIRECTORY "${CMAKE_BINARY_DIR}/src/" DESTINATION include FILES_MATCHING PATTERN "*.h")
 
-# Executable
+# Build the executable
 if(WANT_EXECUTABLE)
     # Set the appropriate lib
     set(LIBSURGESCRIPT "surgescript")
@@ -165,6 +169,7 @@
     # Create the executable
     message(STATUS "Will build surgescript")
     add_executable(surgescript.bin src/main.c)
+    include_directories("${CMAKE_BINARY_DIR}/src")
     target_link_libraries(surgescript.bin ${LIBSURGESCRIPT})
     target_include_directories(surgescript.bin PRIVATE src)
     set_target_properties(surgescript.bin PROPERTIES OUTPUT_NAME surgescript)
@@ -174,15 +179,16 @@
         if(NOT CMAKE_RC_COMPILER)
             set(CMAKE_RC_COMPILER windres)
         endif()
-        execute_process(COMMAND "${CMAKE_RC_COMPILER}" -O coff -o "${CMAKE_CURRENT_BINARY_DIR}/iconwin.res" -i "${CMAKE_SOURCE_DIR}/src/surgescript/misc/iconwin.rc" -I "${CMAKE_SOURCE_DIR}")
-        set_target_properties(surgescript.bin PROPERTIES LINK_FLAGS "-static-libgcc \"${CMAKE_CURRENT_BINARY_DIR}/iconwin.res\"")
+        execute_process(COMMAND "${CMAKE_RC_COMPILER}" -O coff -o "${CMAKE_BINARY_DIR}/iconwin.res" -i "${CMAKE_SOURCE_DIR}/src/surgescript/misc/iconwin.rc" -I "${CMAKE_SOURCE_DIR}")
+        set_target_properties(surgescript.bin PROPERTIES LINK_FLAGS "-static-libgcc \"${CMAKE_BINARY_DIR}/iconwin.res\"")
     endif()
 
     # *nix metadata & icon
     if(UNIX)
-        generate_file("surgescript.appdata.xml")
-        install(FILES ${CMAKE_CURRENT_BINARY_DIR}/surgescript.appdata.xml DESTINATION "${METAINFO_PATH}")
-        install(FILES src/surgescript/misc/surgescript.png DESTINATION "${ICON_PATH}")
+        file(TO_CMAKE_PATH "${CMAKE_INSTALL_PREFIX}/${ICON_PATH}/surgescript.png" ICON_FILEPATH)
+        generate_file("misc/surgescript.appdata.xml")
+        install(FILES "${CMAKE_BINARY_DIR}/src/surgescript/misc/surgescript.appdata.xml" DESTINATION "${CMAKE_INSTALL_PREFIX}/${METAINFO_PATH}")
+        install(FILES src/surgescript/misc/surgescript.png DESTINATION "${CMAKE_INSTALL_PREFIX}/${ICON_PATH}")
     endif()
 
     # Installing the executable
