=== debian/changelog ===
surgescript (0.5.5-1) experimental; urgency=medium

  [ Carlos Donizete Froes ]
  * New upstream release.
    + Added the ability to pause the SurgeScript VM.
    + Added utility macros for checking the SurgeScript version at compile time.
    + Introduced a dedicated module for keeping track of time.
    + Renamed Object.childCount to Object.__childCount.
    + Updated docs.
  * debian/copyright:
    + Copyright updated for current years (2021).
  * debian/control:
    + Changed versioned in "depends+breaks+replaces" to avoid version conflict.
  * Renamed for debian/libsurgescript0.5.5 file.
  * Updated debian/upstream/metadata years (2021).

  [ Tobias Frost ]
  * Team upload.
  * Upload to experimental.

 -- Carlos Donizete Froes <coringao@riseup.net>  Fri, 22 Jan 2021 22:51:14 -0300
