=== debian/control ===
--- 
+++ 
@@ -11,7 +11,6 @@
 Vcs-Git: https://salsa.debian.org/games-team/surgescript.git
 
 Package: surgescript
-Section: games
 Architecture: any
 Depends: ${misc:Depends}, ${shlibs:Depends}
 Description: Scripting language for games
@@ -30,7 +29,7 @@
  Some of the best practices have been incorporated into the language itself,
  making things really easy for developers and modders.
 
-Package: libsurgescript0.5.4.4
+Package: libsurgescript0.5.5
 Architecture: any
 Multi-Arch: same
 Depends: ${misc:Depends}, ${shlibs:Depends}
@@ -55,9 +54,9 @@
 Package: libsurgescript-dev
 Section: libdevel
 Architecture: any
-Breaks: surgescript (<< 0.5.4.4)
-Replaces: surgescript (<< 0.5.4.4)
-Depends: libsurgescript0.5.4.4 (= ${binary:Version}), ${misc:Depends}
+Breaks: surgescript (<< 0.5.5)
+Replaces: surgescript (<< 0.5.5)
+Depends: libsurgescript0.5.5 (= ${binary:Version}), ${misc:Depends}
 Description: Scripting language for games (development files)
  Unleash your creativity! With SurgeScript, you unleash your creativity
  and create your own amazing interactive content.
