=== debian/rules ===
--- 
+++ 
@@ -15,8 +15,7 @@
 
 override_dh_auto_configure:
 	dh_auto_configure -- \
-		-DLIB_SUFFIX=/$(DEB_HOST_MULTIARCH) \
-		-DCMAKE_SKIP_RPATH=ON
+		-DLIB_SUFFIX=/$(DEB_HOST_MULTIARCH)
 
 override_dh_compress:
 	dh_compress -X.ss
