=== debian/changelog ===
surgescript (0.6.1-1) unstable; urgency=medium

  * Team Upload
  * Do not explicity set PIE flag (Closes: ##1125661)
  * New upstream version 0.6.1
  * Refresh patch
  * Disable useless Salsa CI jobs
  * Bump Standards-Version to 4.7.3, drop Priority: tag
  * Rewrite d/watch in v5 format

 -- Alexandre Detiste <tchet@debian.org>  Wed, 04 Feb 2026 00:43:56 +0100

surgescript (0.5.4.4-2) unstable; urgency=medium

  * Team Upload
  * Patch for CMake4 (Closes: #1113551)
  * Apply Multi-Arch: hint
  * Add debian/salsa-ci.yml

 -- Alexandre Detiste <tchet@debian.org>  Wed, 19 Nov 2025 16:09:41 +0100
