=== debian/control ===
--- 
+++ 
@@ -1,18 +1,22 @@
 Source: surgescript
 Section: libs
-Priority: optional
 Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
-Uploaders: Carlos Donizete Froes <coringao@riseup.net>
-Build-Depends: cmake, debhelper-compat (= 13)
-Standards-Version: 4.5.1
-Rules-Requires-Root: no
+Uploaders:
+ Carlos Donizete Froes <coringao@riseup.net>,
+Build-Depends:
+ debhelper-compat (= 13),
+ cmake,
+Standards-Version: 4.7.3
 Homepage: https://docs.opensurge2d.org
 Vcs-Browser: https://salsa.debian.org/games-team/surgescript
 Vcs-Git: https://salsa.debian.org/games-team/surgescript.git
 
 Package: surgescript
+Section: games
 Architecture: any
-Depends: ${misc:Depends}, ${shlibs:Depends}
+Depends:
+ ${misc:Depends},
+ ${shlibs:Depends},
 Description: Scripting language for games
  Unleash your creativity! With SurgeScript, you unleash your creativity
  and create your own amazing interactive content.
@@ -29,10 +33,12 @@
  Some of the best practices have been incorporated into the language itself,
  making things really easy for developers and modders.
 
-Package: libsurgescript0.5.5
+Package: libsurgescript0.5.4.4
 Architecture: any
 Multi-Arch: same
-Depends: ${misc:Depends}, ${shlibs:Depends}
+Depends:
+ ${misc:Depends},
+ ${shlibs:Depends},
 Description: Scripting language for games (library files)
  Unleash your creativity! With SurgeScript, you unleash your creativity
  and create your own amazing interactive content.
@@ -54,9 +60,14 @@
 Package: libsurgescript-dev
 Section: libdevel
 Architecture: any
-Breaks: surgescript (<< 0.5.5)
-Replaces: surgescript (<< 0.5.5)
-Depends: libsurgescript0.5.5 (= ${binary:Version}), ${misc:Depends}
+Multi-Arch: same
+Breaks:
+ surgescript (<< 0.5.4.4),
+Replaces:
+ surgescript (<< 0.5.4.4),
+Depends:
+ libsurgescript0.5.4.4 (= ${binary:Version}),
+ ${misc:Depends},
 Description: Scripting language for games (development files)
  Unleash your creativity! With SurgeScript, you unleash your creativity
  and create your own amazing interactive content.
